BABYL OPTIONS:
Version: 5
Labels:
Note:   This is the header of an rmail file.
Note:   If you are seeing it in rmail,
Note:    it means the file has no messages in it.

1,,
Received: from zeus by icot21.icot.or.jp (5.61/6.4J.6-icotv6)
	id AA17035; Thu, 23 Jul 92 18:24:50 +0900
Received: from icot.icot.or.jp by zeus.icot.or.jp (4.1/6.4J.6-zeus)
	id AA03331; Thu, 23 Jul 92 18:26:14 JST
Received: from zeus.icot.or.jp ([192.50.194.162]) by icot.icot.or.jp (5.65+1.6W/6.4J.6-icotv3)
	id AA29044; Thu, 23 Jul 92 18:26:27 JST
Received: by zeus.icot.or.jp (4.1/6.4J.6-zeus)
	id AA03328; Thu, 23 Jul 92 18:26:12 JST
Date: Thu, 23 Jul 92 18:26:12 JST
From: Horikawa Tsutomu <mahorika@icot.or.jp>
Return-Path: <mahorika@icot.or.jp>
Message-Id: <9207230926.AA03328@zeus.icot.or.jp>
To: sano@icot.or.jp
Subject: SFTB
Status: RO

*** EOOH ***
Date: Thu, 23 Jul 92 18:26:12 JST
From: Horikawa Tsutomu <mahorika@icot.or.jp>
Return-Path: <mahorika@icot.or.jp>
To: sano@icot.or.jp
Subject: SFTB


%
%  dcg2etl
%

%
% convert dictionary
%
dictionary :- !,
	see(user),
	write('DCG file name: '),
	ttyflush,
	read(Name1),
	(name(DcgFile, Name1) -> true; DcgFile = Name1),
	write('ETL parser file name: '),
	ttyflush,
	read(Name2),
	(name(EtlFile, Name2) -> true; EtlFile = Name2),
	dictionary(DcgFile, EtlFile).

dictionary(DcgFile, EtlFile) :- !,
	see(DcgFile),
	tell(EtlFile),
	repeat,
	    read(Term),
	    dict_scan(Term, Word, Cat, Syn, Rel, F),
	    dict_conv(Word, Cat, Syn, Rel, F, Term),
	Term == end_of_file,
	seen,
	told.

dict_scan(end_of_file, _, _, _, _, _) :- !.
dict_scan((Head --> [Word],{A1,A2,A3}), Word, Cat, Syn, Rel, F) :-
	functor(Head, Cat, _),
	dict_scan_syn(A1, Syn),
	dict_scan_rel(A2, Rel),
	dict_scan_f(A3, F), !.
dict_scan(Term, _, _, _, _, _) :- !,
	error_msg([write('illegal syntax : '), write(Term), nl]).

dict_scan_syn((_ = Syn), Syn) :-
	list(Syn), !,
	dict_scan_syn1(Syn, _).
dict_scan_syn(Syn, _) :- !,
	error_msg([write('illegal syntax : '), write(Syn), nl]),
	fail.

dict_scan_syn1([], X) :- !, var(X).
dict_scan_syn1([Term|Rest], X) :- !,
	(functor(Term, _, 1) ->
	    true;
	    write('illegal term : '),
	    write(Term),
	    nl,
	    X = false),
	dict_scan_syn1(Rest, X).

dict_scan_rel((_ = Rel), Rel) :-
	list(Rel), !,
	dict_scan_rel1(Rel, _).
dict_scan_rel(Rel, _) :- !,
	error_msg([write('illegal syntax : '), write(Rel), nl]),
	fail.

dict_scan_rel1([], X) :- !, var(X).
dict_scan_rel1([Term|Rest], X) :- !,
	dict_scan_rel2(Term, X), !,
	dict_scan_rel1(Rest, X).

dict_scan_rel2(Term, _) :-
	functor(Term, Func, Arity),
	((Arity == 2, Func \== $B;XI8(B); (Arity == 1, Func == $B;XI8(B)), !.
dict_scan_rel2(Term, false) :- !,
	error_msg([write('illegal term : '), write(Term), nl]).

dict_scan_f((_ = (F1, F2)), (F1, F2)) :- !,
	dict_scan_f1(F1, X),
	dict_scan_f1(F2, Y),
	!,
	var(X),
	var(Y).
dict_scan_f(F, _) :- !,
	error_msg([write('illegal syntax : '), write(F), nl]),
	fail.

dict_scan_f1([], _) :- !.
dict_scan_f1([Term|Rest], X) :- !,
	dict_scan_f2(Term, X), !,
	dict_scan_f1(Rest, X).

dict_scan_f2((_, _, _), _) :- !.
dict_scan_f2(Term, false) :- !,
	error_msg([write('illegal term : '), write(Term), nl]).

dict_conv(end_of_file, _, _, _, _, _) :- !.
dict_conv(Word, Cat, Syn, Rel, F, _) :-
	put_left_p,
	write(Word),
	put_space,
	write(Cat),
	nl,
	put_space,
	put_quote,
	put_left_p,
	dict_write_syn(Syn),
	nl,
	put_space(3),
	dict_write_x,
	nl,
	put_space(3),
	dict_write_rel(Rel),
	nl,
	put_space(3),
	dict_write_f(F),
	nl,
	put_space(3),
	dict_write_pro,
	put_right_p,
	nl,
	put_space,
	write(nil),
	put_right_p,
	nl,
	nl, !.
dict_conv(_, _, _, _, _, Term) :- !,
	error_msg([write('error : '), write(Term), nl]).

dict_write_syn([First|Rest]) :- !,
	put_left_p,
	dict_write_syn_term(First),
	dict_write_syn_list(Rest),
	put_right_p.
	
dict_write_syn_list([]) :- !.
dict_write_syn_list([Term|Rest]) :- !,
	put_space,
	dict_write_syn_term(Term), !,
	dict_write_syn_list(Rest).

dict_write_syn_term(Term) :- !,
	Term =.. [Func|Args],
	put_left_p,
	write(Func),
	dict_write_syn_args(Args),
	put_right_p.

dict_write_syn_args([]) :- !.
dict_write_syn_args([Atom|Rest]) :- !,
	put_space,
	write(Atom), !,
	dict_write_syn_args(Rest).

dict_write_x :- !,
	put_left_p,
	write(x),
	put_space,
	write('@1'),
	put_right_p.

dict_write_rel(Rel) :- !,
	dict_write_rel_var_check(Rel, 2),
	Rel = [First|Rest],
	put_left_p,
	dict_write_rel_term(First),
	dict_write_rel_list(Rest),
	put_right_p.

dict_write_rel_var_check([], _) :- !.
dict_write_rel_var_check([Term|Rest], N) :- !,
	Term =.. [Func|Args],
	dict_write_rel_var_name(Func, Args, N, NN), !,
	dict_write_rel_var_check(Rest, NN).

dict_write_rel_var_name($B;XI8(B, ['@1'], N, N) :- !.
dict_write_rel_var_name(_, Args, N, NN) :- !,
	dict_write_rel_var_args(Args, N, NN).

dict_write_rel_var_args([], N, N) :- !.
dict_write_rel_var_args([V|Rest], N, NN) :-
	var(V),
	!,
	ascii_code(N, C),
	append("@", [C], X),
	name(V, X),
	I is N + 1,
	dict_write_rel_var_args(Rest, I, NN).
dict_write_rel_var_args([_|Rest], N, NN) :- !,
	dict_write_rel_var_args(Rest, N, NN).

dict_write_rel_list([]) :- !.
dict_write_rel_list([Term|Rest]) :- !,
	put_space,
	dict_write_rel_term(Term), !,
	dict_write_rel_list(Rest).

dict_write_rel_term(Term) :-
	Term =.. [Func|Args],
	put_left_p,
	write(Func),
	dict_write_rel_args(Args),
	put_right_p.

dict_write_rel_args([]) :- !.
dict_write_rel_args([Atom|Rest]) :- !,
	put_space,
	write(Atom), !,
	dict_write_rel_args(Rest).

dict_write_f(([], [])) :- !,
	put_left_p,
	write(nil),
	put_space,
	write(nil),
	put_right_p.
dict_write_f(([FTerm|FRest], [])) :- !,
	put_left_p,
	put_left_p,
	dict_write_f_term(FTerm),
	dict_write_f_list(FRest),
	put_right_p,
	put_space,
	write(nil),
	put_right_p.
dict_write_f(([], [RTerm|RRest])) :- !,
	put_left_p,
	write(nil),
	put_space,
	put_left_p,
	dict_write_f_term(RTerm),
	dict_write_f_list(RRest),
	put_right_p,
	put_right_p.
dict_write_f(([FTerm|FRest], [RTerm|RRest])) :- !,
	put_left_p,
	put_left_p,
	dict_write_f_term(FTerm),
	dict_write_f_list(FRest),
	put_right_p,
	put_space,
	put_left_p,
	dict_write_f_term(RTerm),
	dict_write_f_list(RRest),
	put_right_p,
	put_right_p.

dict_write_f_list([]) :- !.
dict_write_f_list([Term|Rest]) :- !,
	put_space,
	dict_write_f_term(Term), !,
	dict_write_f_list(Rest).

dict_write_f_term((F1, F2, F3)) :- !,
	put_left_p,
	write(F1),
	put_space,
	write(F2),
	put_space,
	write(F3),
	put_right_p.

dict_write_pro :- !,
	put_left_p,
	write(pro),
	put_right_p.

%
% utilities
%

put_left_p :- !, put("(").
put_right_p :- !, put(")").
put_quote :- !, put("'").
put_space :- !, put(" ").

put_space(0) :- !.
put_space(N) :- !,
	put(" "),
	NN is N - 1, !,
	put_space(NN).

append([], X, X) :- !.
append([S|X], Y, [S|Z]) :- !,
	append(X, Y, Z).

ascii_code(N, C) :- !, C is 48 + N.

list([_|_]) :- !.
list([]) :- !.
list(_) :- !, fail.

error_msg(Msg) :- !,
	telling(Old),
	tell(user),
	err_msg(Msg),
	told,
	tell(Old).

err_msg([]) :- !.
err_msg([Pred|Rest]) :- !,
	Pred,
	err_msg(Rest).

