
% (C) Copyright 1992
% Institute for New Generation Computer Technology, Japan
% ALL RIGHTS RESERVED

% Query
% :- dic_itiran(InFile,OutFile)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                           %
%  ΰĤ    1992-07-15                         %
%                                                           %
%        nkf -a ե̾ > ե̾                 %
%    sicstus Prolog ˤϤ                                %
%    [ե̾].                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dic_itiran(InFile,OutFile)  :- !,
    open(InFile,read, St),
    open(OutFile,write, St2),
    make_list(St,St2),
    close(St),
    close(St2).

make_list(St,St2) :-
  check_end(St,End),
  (End \== 1 ->
    get_hinsi(St,[],H_list),
    get_entry(St,St2,[],0),
    get_yomi(St,St2,[]),
    get_next_data(St,0,End2),
    (End2 \== 1 ->
      format(St2,"~s",["ʻ   "]),
      write_hinsi(St2,H_list),
      format(St2,"~n",[]),
      format(St2,"~n",[]),
      make_list(St,St2)
     ;
      !
    )
   ; !).

check_end(St,End) :-
  get(St,D),
  ([D] == "(" -> 
     End = 0
   ;
     End = 1
  ).
%%%%  ʻǡФ
get_hinsi(St,Old,Kekka) :-
  get(St,D1),
  (D1 \== end_of_file ->
    ([D1] \== "(" ->
      append(Old,[D1],New),
      get_hinsi(St,New,Kekka)
       ;
      Kekka = Old
    )
     ;
   Kekka = []
  ).
%%%%  Фǡ񤭽Ф
get_entry(St,St2,Old,Count) :-
    get(St,D1),
   (D1 \== end_of_file ->
     ([D1] \== ")"  ->
        (Count @> 1 ->
         append(Old,[D1],New)
           ;
         !),
       ([D1] == "(" ->
         NewCount is Count + 1
         ;
         NewCount = Count),         
         get_entry(St,St2,New,NewCount)
       ;
         write_data1(Old,St2,1)
     )
   ;
       !).

%%%% ɤߥǡ񤭽Ф
get_yomi(St,St2,Old) :-
    get(St,D1),
   (D1 \== end_of_file ->
     ([D1] \== ")"  ->
        ([D1] \== "(" ->
         append(Old,[D1],New)
           ;
         !),
         get_yomi(St,St2,New)
       ;
         write_data2(Old,St2,1)
     )
   ;
       !).

%%%% Υǡ  N: )ɤο
get_next_data(St,Count,End) :-
  get(St,D1),
  (D1 \== end_of_file ->
      check_daikakko(D1,Flag),
      (Flag \== 1 ->
         get_next_data(St,Count,End)
         ;
         go_kakko(St,0,5)
      )
   ;
   End = 1
  ).

check_daikakko(D1,Flag) :-
  ([D1] \== "}" ->
    Flag = 0
    ;
    Flag = 1
  ).

go_kakko(St,Count,Owari) :-
  (Count @< Owari ->
    get(St,D),
    New_count is Count + 1,
    go_kakko(St,New_count,Owari)
    ;
    !).

%%%% ڤ
append([],X,X) :- !.
append([A|B],C,[A|D]) :- append(B,C,D).

%%%% ꥹȤȤ񤭽Ф
write_data1([],St2,Count) :- 
  Blank is 28 - Count,
  write_blank(St2,Blank).
write_data1([A|B],St2,Count) :-
  put(St2,A),
    (Count == 8 ->
    format(St2,"~s",["   "])
    ; !),
  New_count is Count + 1,
  write_data1(B,St2,New_count).

write_data2([],St2,Count) :- 
   Blank is 38 - Count,
   write_blank(St2,Blank).
write_data2([A|B],St2,Count) :-
  put(St2,A),
  (Count == 4 ->
    format(St2,"~s",["   "])
     ; !),
  New_count is Count + 1,
  write_data2(B,St2,New_count).

write_blank(St2,0) :- !.
write_blank(St2,Count) :-
  format(St2,"~s",[" "]),
  New_count is Count - 1,
  write_blank(St2,New_count).

write_hinsi(St2,[]) :- !.
write_hinsi(St2,[A|B]) :-
  put(St2,A),
  write_hinsi(St2,B).

% End of File
